package de.tudarmstadt.langtech.substituter.util;

import java.util.HashMap;

/**
 * Maps fullforms to lemma.
 * 
 * @author cwirth
 *
 */
public class LemmaMatcher {

	private HashMap<String,String> matches = new HashMap<String,String>();
	
	/**
	 * 
	 * @param filename the file name to the lemma map file. See README.txt
	 */
	public LemmaMatcher(String filename) {
		TextFile file = new TextFile(filename);
		for(String line : file) {
			String[] split = line.split("\t");
			if(split.length==2)
				matches.put(split[1], split[0]);
		}
	}
	
	/**
	 * 
	 * @param word the fullform
	 * @return the lemma or the fullform if no mapping was available
	 */
	public String getLemma(String word) {
		if(matches.containsKey(word)) {
			return matches.get(word);
		}
		return word;
	}
}
