/*
 * Viterbitagger.java
 *
 * Created on 1. Dezember 2005, 20:26
 *
 * A simple Viterbi tagger with a history horizont of 2.
 */

package de.tudarmstadt.langtech.viterbitagger;
import java.util.*;

/**
 *
 * @author BIEMANN
 */
public class Viterbitagger {
    

    static String prefixfile;   
    static String lexiconfile;
    static String taglistfile;
    static String transitionfile;
    static String textfile;
    static Tagger tagger;
    Lexicon lexicon;
    String[] taglist;


    public Viterbitagger(String taggerpath) {
        this.init(taggerpath);
    }

    /* default with ptb-en tagger */
    public Viterbitagger() {
        this.init(new String("posdata/ptb3-tagger"));
    }



    /**
     * loads tagger
     */
    public void init(String taggerfile) {
        prefixfile=taggerfile;
        lexiconfile=prefixfile+".lexicon";
        taglistfile=prefixfile+".taglist";
        transitionfile=prefixfile+".transitions";
        tagger=new Tagger(taglistfile,lexiconfile,transitionfile);
    }

    public Vector addPOStags(Vector toTag) {
        return tagger.tagVector(toTag);
    } // end public main


    public String addPOStags(String toTag) {
        return tagger.tagString(toTag);
    } // end public main

    
} // end class Viterbitagger
